(uiop:define-package #:odo
  (:use)
  (:export
   #:*
   #:+
   #:-
   #:/
   #:=
   #:*current-time*
   #:*domain-query-functions*
   #:*previous-time*
   #:+-infinity+
   #:+current-time+
   #:+infinity+
   #:+previous-time+
   #:+variable-inactive-value+
   #:->
   #:<->
   #:@
   #:activation-status
   #:activep
   #:activity-args
   #:activity-name
   #:add-chance-constraint!
   #:add-constraint!
   #:add-episode!
   #:add-goal-episode!
   #:add-interface-variable!
   #:add-location!
   #:add-state-constraint!
   #:add-state-variable!
   #:add-transition!
   #:add-value-episode!
   #:agent-separation
   #:all-diff
   #:all-diff-except
   #:and
   #:annotation
   #:annotation-iterator
   #:annotation-plist
   #:application-expression
   #:application-expression-p
   #:args
   #:argument-value
   #:argument-value-by-type
   #:arguments
   #:assigned-p
   #:assigned-value
   #:attribute-objective-function
   #:attribute-objective-function-p
   #:attribute-values-alist
   #:automaton
   #:automaton-transition
   #:automaton-transition-branch
   #:avoids-obstacles
   #:b
   #:bdd
   #:bdd-p
   #:bdd-to-dot-stream
   #:boolean-domain
   #:boolean-domain-p
   #:booleanize-conjunctions
   #:booleanize-disjunctions
   #:booleanize-reifs
   #:bounds
   #:bounds-by-type
   #:branches
   #:c
   #:canonicalize-domain-description
   #:capacity
   #:chance-constraint
   #:chance-constraint-iterator
   #:chance-constraint-list
   #:chance-constraint-p
   #:child-high
   #:child-low
   #:circuit
   #:cl-eql
   #:cl-equal
   #:cl-equalp
   #:clock-parameters
   #:clock-resets
   #:clock-variables
   #:concurrent-automaton
   #:condition
   #:conditional-event
   #:conditional-p
   #:conditional-variable
   #:conditional-variable-p
   #:constraint
   #:constraint-automaton-p
   #:constraint-error
   #:constraint-iterator
   #:constraint-list
   #:constraint-p
   #:contingent-constraint
   #:controllable-conditional-event
   #:controllable-conditional-variable
   #:controllable-event
   #:controllable-variable
   #:copy
   #:copy-by-type
   #:csp
   #:csp-equal
   #:csp-error
   #:csp-expression-transform
   #:csp-p
   #:csp-transform
   #:csp-variable-transform
   #:cumulative
   #:d/dn
   #:d/dt
   #:d/dx
   #:define-domain-query
   #:delayed-p
   #:delta
   #:derivative
   #:derivative-by-type
   #:deserialize
   #:deserialize-from-file
   #:deserialize-from-stream
   #:deserialize-from-string
   #:discrete-domain
   #:discrete-domain-p
   #:distribution
   #:domain
   #:domain-equal
   #:domain-error
   #:domain-p
   #:domain-spec
   #:domain-test
   #:domain-type
   #:domain-type-spec
   #:durations
   #:effect
   #:element
   #:elements
   #:end-constraints
   #:end-event
   #:entailed-p
   #:enum-map-integer-value
   #:enum-map-orig-value
   #:enums-to-ints
   #:episode
   #:episode-p
   #:equal
   #:equal-p
   #:equal-p-by-type
   #:eval-expression
   #:eval-expression-by-type
   #:evaluate-objective
   #:event-iterator
   #:event-list
   #:event
   #:event-p
   #:every
   #:except
   #:expression
   #:expression-p
   #:expression-to-references
   #:expression-to-sexp
   #:expression-to-sexp-by-type
   #:externalize
   #:externalize-state-space
   #:failure-probability
   #:features
   #:forms
   #:from
   #:funcall
   #:function
   #:ge
   #:geom
   #:geom-within
   #:get-constraint
   #:get-interface-variable
   #:get-location
   #:get-state-variable
   #:get-transition
   #:goal-episode-iterator
   #:goal-episode-list
   #:gt
   #:guard
   #:hierarchical-automaton
   #:hierarchical-automaton-all
   #:hierarchical-automaton-xor
   #:identity-transform
   #:in-domain-p
   #:incoming-transitions
   #:index
   #:integer-domain
   #:integer-domain-p
   #:interface-variables
   #:internalize
   #:it-done
   #:it-list
   #:it-next
   #:le
   #:left
   #:linear-/=
   #:linear-<
   #:linear-<=
   #:linear-=
   #:linear->
   #:linear->=
   #:location-variable
   #:locations
   #:lookup
   #:lookup-expression
   #:lookup-expression-name
   #:looping-simple-temporal
   #:lower-bound
   #:lower-bound-slack
   #:lt
   #:make-attribute-objective-function
   #:make-automaton-transition
   #:make-automaton-transition-branch
   #:make-bdd
   #:make-boolean-domain
   #:make-boolean-variable
   #:make-chance-constraint
   #:make-concurrent-automaton
   #:make-conditional-boolean-variable
   #:make-conditional-enumerated-variable
   #:make-conditional-integer-variable
   #:make-conditional-real-variable
   #:make-conditional-variable
   #:make-constraint
   #:make-csp
   #:make-domain
   #:make-enumerated-domain
   #:make-enumerated-variable
   #:make-episode
   #:make-event
   #:make-guarded-constraint
   #:make-hash-table-value-iterator
   #:make-integer-domain
   #:make-integer-variable
   #:make-iterator
   #:make-instance
   #:make-list-iterator
   #:make-pddl-control-variable
   #:make-pddl-domain
   #:make-pddl-durative-action
   #:make-pddl-function
   #:make-pddl-parameter
   #:make-pddl-predicate
   #:make-pddl-snap-action
   #:make-pddl-type
   #:make-primitive-automaton
   #:make-primitive-location
   #:make-real-domain
   #:make-real-variable
   #:make-state-constraint
   #:make-state-plan
   #:make-state-space
   #:make-state-variable
   #:make-transition-constraint
   #:make-variable
   #:make-variable-vector
   #:map
   #:max
   #:max-val
   #:median
   #:min
   #:min-val
   #:more-numbers
   #:mu
   #:n
   #:name
   #:ne
   #:negative-infinity
   #:normal-cdf-=
   #:not
   #:number
   #:number-loops
   #:numbers
   #:object
   #:objective
   #:objective-function
   #:objective-goal
   #:observations
   #:once-constraints
   #:one-indexed-p
   #:operator
   #:or
   #:outgoing-transitions
   #:over-all-constraints
   #:p1
   #:p2
   #:pddl-action
   #:pddl-action-duration
   #:pddl-action-parameters
   #:pddl-assign
   #:pddl-at
   #:pddl-constant
   #:pddl-constant-type
   #:pddl-control-variable
   #:pddl-control-variable-parameters
   #:pddl-decrease
   #:pddl-domain
   #:pddl-domain-action
   #:pddl-domain-actions
   #:pddl-domain-constant
   #:pddl-domain-constants
   #:pddl-domain-control-variable
   #:pddl-domain-control-variables
   #:pddl-domain-function
   #:pddl-domain-functions
   #:pddl-domain-predicate
   #:pddl-domain-predicates
   #:pddl-domain-requirements
   #:pddl-domain-type
   #:pddl-domain-types
   #:pddl-durative-action
   #:pddl-function
   #:pddl-function-parameters
   #:pddl-function-type
   #:pddl-increase
   #:pddl-over
   #:pddl-parameter
   #:pddl-parameter-type
   #:pddl-predicate
   #:pddl-predicate-parameters
   #:pddl-snap-action
   #:pddl-type
   #:point
   #:positive-infinity
   #:predicate
   #:primitive-automaton
   #:primitive-location
   #:print-odo-conditional-variable
   #:print-odo-domain
   #:print-odo-variable
   #:probabilistic-automaton-p
   #:probabilistic-duration
   #:probability
   #:pure-boolean-domain
   #:pure-discrete-domain
   #:pure-integer-domain
   #:pure-real-domain
   #:range
   #:range-at
   #:range-iterator
   #:range-list
   #:read-csp-from-file
   #:real-domain
   #:real-domain-p
   #:regret-max
   #:regret-min
   #:remove-constraint!
   #:remove-interface-variable!
   #:remove-state-constraint!
   #:remove-transition!
   #:reset-domains
   #:reset-domains/source-csp
   #:reset-domains/variables
   #:resources
   #:right
   #:satisfiable-p
   #:scope
   #:scope-by-type
   #:serialize-to-file
   #:serialize-to-stream
   #:serialize-to-string
   #:sets
   #:sigma
   #:simple-csp-error
   #:simple-temporal
   #:size
   #:soft-simple-temporal
   #:some
   #:source
   #:sparse-vector-indices
   #:start-constraints
   #:start-event
   #:starts
   #:state-constraint
   #:state-constraint-iterator
   #:state-constraint-list
   #:state-constraint-p
   #:state-plan-feature-p
   #:state-plan
   #:state-plan-p
   #:state-space
   #:state-space-add!
   #:state-space-add-by-type!
   #:state-space-assigned-p
   #:state-space-error
   #:state-space-get
   #:state-space-iterator
   #:state-space-list
   #:state-space-p
   #:state-variable
   #:state-variable-p
   #:state-variables
   #:state-variable-time-domain
   #:subcircuit
   #:supertype
   #:symbolic-infinity-p
   #:target
   #:temporal-constraint
   #:temporal-to-linear
   #:terminal-p
   #:test-fun
   #:time
   #:time-interval
   #:time-specifier
   #:timed-automaton-p
   #:to
   #:tolerance
   #:transform
   #:transform-csp
   #:transform-csp/annotation
   #:transform-csp/annotations
   #:transform-csp/application-expression-by-operator
   #:transform-csp/constraint
   #:transform-csp/constraints
   #:transform-csp/expression
   #:transform-csp/expression-by-type
   #:transform-csp/objective
   #:transform-csp/variable
   #:transform-csp/variables
   #:transform-recurses-on-nested-expressions
   #:transition-constraint
   #:transition-constraint-p
   #:transitions
   #:type
   #:type-p
   #:uncontrollable-conditional-event
   #:uncontrollable-conditional-variable
   #:uncontrollable-delayed-event
   #:uncontrollable-event
   #:uncontrollable-p
   #:uncontrollable-variable
   #:unknown-annotation-externalization
   #:unknown-annotation-externalization-key
   #:unknown-object-externalization
   #:unknown-object-externalization-object
   #:upper-bound
   #:upper-bound-slack
   #:value
   #:value-episode-iterator
   #:value-episode-list
   #:value-iterator
   #:value-list
   #:values
   #:variable
   #:variable-activation-status
   #:variable-p
   #:variable-vector-p
   #:variables
   #:width
   #:write-csp-to-file
   #:write-csp-to-stream
   #:write-flatzinc-solution
   #:write-state-space-to-file
   #:write-state-space-to-stream
   #:x
   #:xor
   #:y)
  ;; Deprecated
  (:export
   #:add-automaton-interface-variable!
   #:add-automaton-location!
   #:add-automaton-state-variable!
   #:add-automaton-transition!
   #:add-location-constraint!
   #:add-state-plan-chance-constraint!
   #:application-argument-value
   #:application-argument-value-by-type
   #:application-arguments
   #:application-operator
   #:attribute-objective-attribute-values-alist
   #:automaton-clock-parameters
   #:automaton-clock-variables
   #:automaton-interface-variables
   #:automaton-location-variable
   #:automaton-locations
   #:automaton-name
   #:automaton-state-variables
   #:automaton-transitions
   #:branch-probability
   #:branch-target
   #:cc-constraint-iterator
   #:cc-constraint-list
   #:cc-failure-probability
   #:cc-name
   #:constraint-expression
   #:constraint-name
   #:csp-state-space
   #:episode-activity-args
   #:episode-activity-name
   #:episode-conditional-p
   #:episode-end-constraints
   #:episode-end-event
   #:episode-name
   #:episode-once-constraints
   #:episode-over-all-constraints
   #:episode-start-constraints
   #:episode-start-event
   #:episode-temporal-constraint
   #:expression-bounds
   #:expression-bounds-by-type
   #:expression-derivative
   #:expression-derivative-by-type
   #:expression-scope
   #:expression-scope-by-type
   #:event-conditional-p
   #:event-delayed-p
   #:event-name
   #:event-observations
   #:event-uncontrollable-p
   #:get-automaton-interface-variable
   #:get-automaton-location
   #:get-automaton-state-variable
   #:get-automaton-transition
   #:location-constraints
   #:location-incoming-transitions
   #:location-name
   #:location-outgoing-transitions
   #:odo-*
   #:odo-+
   #:odo--
   #:odo-/
   #:odo-=
   #:odo-and
   #:odo-application-expression
   #:odo-application-expression-p
   #:odo-attribute-objective-function
   #:odo-automaton
   #:odo-automaton-transition
   #:odo-automaton-transition-branch
   #:odo-chance-constraint
   #:odo-chance-constraint-p
   #:odo-concurrent-automaton
   #:odo-conditional-event
   #:odo-conditional-p
   #:odo-conditional-variable
   #:odo-conditional-variable-p
   #:odo-constraint
   #:odo-constraint-p
   #:odo-contingent-constraint
   #:odo-controllable-conditional-event
   #:odo-controllable-conditional-variable
   #:odo-controllable-event
   #:odo-controllable-variable
   #:odo-copy
   #:odo-copy-by-type
   #:odo-csp
   #:odo-csp-p
   #:odo-domain
   #:odo-domain-p
   #:odo-episode
   #:odo-episode-p
   #:odo-equal
   #:odo-equal-p
   #:odo-equal-p-by-type
   #:odo-event
   #:odo-event-p
   #:odo-every
   #:odo-expression
   #:odo-expression-p
   #:odo-funcall
   #:odo-hierarchical-automaton
   #:odo-hierarchical-automaton-all
   #:odo-hierarchical-automaton-xor
   #:odo-lookup-expression
   #:odo-make-instance
   #:odo-negative-infinity
   #:odo-not
   #:odo-object
   #:odo-or
   #:odo-primitive-automaton
   #:odo-primitive-location
   #:odo-positive-infinity
   #:odo-some
   #:odo-state-constraint
   #:odo-state-constraint-p
   #:odo-state-plan
   #:odo-state-plan-p
   #:odo-state-space
   #:odo-state-space-p
   #:odo-state-variable
   #:odo-state-variable-p
   #:odo-transform
   #:odo-transition-constraint
   #:odo-transition-constraint-p
   #:odo-type
   #:odo-type-p
   #:odo-uncontrollable-conditional-event
   #:odo-uncontrollable-conditional-variable
   #:odo-uncontrollable-delayed-event
   #:odo-uncontrollable-event
   #:odo-uncontrollable-variable
   #:odo-variable
   #:odo-variable-p
   #:odo-xor
   #:pddl-action-condition
   #:pddl-action-effect
   #:pddl-action-name
   #:pddl-constant-name
   #:pddl-control-variable-bounds
   #:pddl-control-variable-name
   #:pddl-domain-name
   #:pddl-function-name
   #:pddl-parameter-name
   #:pddl-predicate-name
   #:pddl-type-name
   #:pddl-type-supertype
   #:primitive-location-name
   #:remove-automaton-interface-variable!
   #:remove-automaton-transition!
   #:remove-location-constraint!
   #:state-plan-chance-constraint-iterator
   #:state-plan-chance-constraint-list
   #:state-plan-constraint-iterator
   #:state-plan-constraint-list
   #:state-plan-episode-iterator
   #:state-plan-episode-list
   #:state-plan-event-iterator
   #:state-plan-event-list
   #:state-plan-features
   #:state-plan-goal-episode-iterator
   #:state-plan-goal-episode-list
   #:state-plan-name
   #:state-plan-objective
   #:state-plan-start-event
   #:state-plan-state-space
   #:state-plan-value-episode-iterator
   #:state-plan-value-episode-list
   #:state-variable-conditional-p
   #:state-variable-name
   #:state-variable-range
   #:state-variable-range-at
   #:state-variable-uncontrollable-p
   #:transition-branches
   #:transition-clock-resets
   #:transition-guard
   #:transition-name
   #:transition-source
   #:variable-name))
